require 'singleton'

module RutokenMgr
  class Preferences
    include Singleton

    def initialize
      @prefs = Hash.new
    end

    def method_missing(id, *args)
      method = id.id2name
      if match = /(.*)=$/.match(method)
        if args.length != 1
          raise "Set method #{method} should be called with " +
            "only one argument (was called with #{args.length})"
        end

        @prefs[match[1]] = args.first
      else
        unless args.empty?
          raise "Get method #{method} should be called " +
            "without argument (was called with #{args.length})"
        end

        @prefs[method]
      end
    end
  end
end
