module RutokenMgr
  module UI
    class AboutDialog < Gtk::AboutDialog
      include GetText
      GetText.bindtextdomain(RutokenMgr::TEXTDOMAIN, nil, nil, "UTF-8")

      GPL = <<EOL
Rutoken Manager is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

RutokenMgr is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with RutokenMgr; see the file COPYING.  If not,
write to the Free Software Foundation, Inc., 51 Franklin Street,
Fifth Floor, Boston, MA 02110-1301 USA.
EOL

      def initialize(parent)
        super
        self.name = RutokenMgr::TITLE
        self.version = RutokenMgr::DISPLAY_VERSION
        self.copyright = RutokenMgr::COPYRIGHT
        self.comments = RutokenMgr::DESCRIPTION
        self.authors = RutokenMgr::AUTHORS
        self.documenters = RutokenMgr::DOCUMENTERS
        self.artists = RutokenMgr::ARTISTS
        self.translator_credits = RutokenMgr::TRANSLATORS.join("\n")
        self.logo = nil
        self.website = RutokenMgr::WEBSITE_URL
        self.license = GPL
        self.transient_for = parent
        self.signal_connect('response') do self.destroy end
      end
    end
  end
end
