module RutokenMgr
  module UI
    class PINDialog < Gtk::Dialog
      include GetText
      GetText.bindtextdomain(RutokenMgr::TEXTDOMAIN, nil, nil, "UTF-8")

      def initialize title, parent, text
        super(title, parent, Gtk::Dialog::MODAL)

        self.window_position = Gtk::Window::POS_CENTER_ON_PARENT
        self.has_separator = true
        self.resizable = true
        self.border_width = 4
        self.vbox.border_width = 12

        table = Gtk::Table.new(2, 2)
        table.row_spacings = 5
        table.column_spacings = 5
        self.vbox.pack_start(table, false, true, 5)

        pin_label = Gtk::Label.new(_("PIN:"))
        pin_label.xalign = 1
        table.attach_defaults(pin_label, 0, 1, 0, 1)

        @pin_entry = Gtk::Entry.new
        @pin_entry.visibility = false
        @pin_entry.text = text
        table.attach_defaults(@pin_entry, 1, 2, 0, 1)

        verify_pin_label = Gtk::Label.new(_("Verify PIN:"))
        verify_pin_label.xalign = 1
        table.attach_defaults(verify_pin_label, 0, 1, 1, 2)

        @verify_pin_entry = Gtk::Entry.new
        @verify_pin_entry.visibility = false
        table.attach_defaults(@verify_pin_entry, 1, 2, 1, 2)

        cancel_button = self.add_button(Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL)
        @ok_button = self.add_button(Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK)
        @ok_button.sensitive = false

        self.set_alternative_button_order([ Gtk::Dialog::RESPONSE_OK,
                                          Gtk::Dialog::RESPONSE_CANCEL ])

        @pin_entry.signal_connect_after('changed') do |instance|
          check_pin_match
        end
        @verify_pin_entry.signal_connect_after('changed') do |instance|
          check_pin_match
        end
      end

      def check_pin_match
        @ok_button.sensitive = (@pin_entry.text.empty? or @pin_entry.text != @verify_pin_entry.text) ? false : true
        @ok_button.grab_default if @ok_button.sensitive?
      end
      private :check_pin_match

      def execute
        show_all
        ret = run
        text = @pin_entry.text
        destroy
        return (ret != Gtk::Dialog::RESPONSE_OK or text.empty?) ? nil : text
      end
    end
  end
end
